﻿Imports System.IO
Imports System.Drawing.Imaging

Public Class Form1

Private BmpBase As Bitmap

Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  LstFiles.DataSource = Directory.GetFiles(Path.Combine(My.Application.Info.DirectoryPath, "Photos")).Select(Function(Filename) New FilenameToDisplay(Filename)).ToList()
End Sub

Private Sub LstFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LstFiles.SelectedIndexChanged
  Dim Filename As String = DirectCast(LstFiles.SelectedItem, FilenameToDisplay)

  BmpBase = Bitmap.FromFile(Filename)
  PctOriginal.BackgroundImage = BmpBase
  LblOriginal.Text = (New FileInfo(Filename)).Length.ToString("# ###")

  Dim Stream As Stream
  Dim Bmp As New Bitmap(BmpBase, 105, 135)
  Dim Quality As Integer

  Stream = PictureProcessors.GetJpegFile(Bmp, 0)
  PctJpg0.BackgroundImage = Bitmap.FromStream(Stream)
  LblJpg0.Text = Stream.Length.ToString("# ###")

  Stream = PictureProcessors.GetJpegFile(Bmp, 70)
  PctJpg70.BackgroundImage = Bitmap.FromStream(Stream)
  LblJpg70.Text = Stream.Length.ToString("# ###")

  Stream = PictureProcessors.ReduceByQuality(Bmp, 4096, Quality)
  If Stream IsNot Nothing Then
    GrpJpg.Text = "Jpg " & Quality & "%"
    PctJpg.BackgroundImage = Bitmap.FromStream(Stream)
    LblJpg.Text = Stream.Length.ToString("# ###")
  Else
    GrpJpg.Text = "Impossible"
    PctJpg.BackgroundImage = Nothing
    LblJpg.Text = 4096.ToString("# ###")
  End If

  'Paint.NET creates better picture, but it's size is larger
  'Dim BmpData As BitmapData = Bmp.LockBits(New Rectangle(0, 0, Bmp.Width, Bmp.Height), ImageLockMode.ReadWrite, PixelFormat.Format8bppIndexed)
  'Bmp.UnlockBits(BmpData)
  'Stream = PictureProcessors.GetPngFile(Bmp)
  'PctPng.BackgroundImage = Bitmap.FromStream(Stream)
  'LblPng.Text = Stream.Length.ToString("# ###")
End Sub

Private Sub BtnCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCopy.Click
  If BmpBase IsNot Nothing Then
    Clipboard.SetImage(BmpBase)
  End If
End Sub

End Class
