﻿Imports System.Drawing.Imaging
Imports System.IO

Module PictureProcessors
  Private JpegCodec As ImageCodecInfo = (From Codec As ImageCodecInfo In ImageCodecInfo.GetImageEncoders() Where Codec.MimeType = "image/jpeg" Select Codec).First
  Private PngCodec As ImageCodecInfo = (From Codec As ImageCodecInfo In ImageCodecInfo.GetImageEncoders() Where Codec.MimeType = "image/png" Select Codec).First
  Private X = String.Join(vbCrLf, CType(System.Drawing.Imaging.ImageCodecInfo.GetImageEncoders(), System.Collections.Generic.IEnumerable(Of System.Drawing.Imaging.ImageCodecInfo)).Select(Function(C) C.CodecName))

  Public Function GetPictureFile(ByVal Pct As Bitmap, ByVal Codec As ImageCodecInfo, ByVal EncoderParams As EncoderParameters) As MemoryStream
    Dim File As New MemoryStream
    Pct.Save(File, Codec, EncoderParams)
    Return File
  End Function


  Public Function GetJpegFile(ByVal Pct As Bitmap, ByVal Quality As Integer) As MemoryStream
    Dim EncoderParams As New EncoderParameters(1)
    EncoderParams.Param(0) = New EncoderParameter(Encoder.Quality, Quality)
    Return GetPictureFile(Pct, JpegCodec, EncoderParams)
  End Function

  Public Function GetPngFile(ByVal Pct As Bitmap) As MemoryStream
    Dim File As New MemoryStream
    Pct.Save(File, ImageFormat.Png)
    Return File
  End Function

  Public Function ReduceByQuality(ByVal Pct As Bitmap, ByVal Lim As Long, ByRef Quality As Integer) As MemoryStream
    Dim LastOk As MemoryStream = Nothing, File As MemoryStream
    Dim L As Long = 0, R As Long = 100, Cur As Long

    Do While L < R
      Cur = (L + R + 1) >> 1
      File = GetJpegFile(Pct, Cur)
      If File.Length > Lim Then
        R = Cur - 1
      Else
        L = Cur
        LastOk = File
        Quality = Cur
      End If
    Loop

    Return LastOk
  End Function

End Module
